#include <stdio.h>
#include <iostream>
using namespace std;

#define MAXPILA 20

//
// Implementacin de pilas con arreglos
class pila {
private:
    char elem[MAXPILA];
    int tope;
public:
    pila(){ tope = -1;};
    void vaciar(){ tope = -1;};
    bool push(char x);
    bool pop (char& x);
    bool top(char& x);
    bool vacia(){ return (tope==-1);};
    bool llena(){ return (tope==MAXPILA-1);};
};


//
// Inserta el elemento enviado como parmetro en la pila, falso si la pila est llena
bool pila::push(char dato){
	if (llena())
		return false;
	elem[++tope]=dato;
	return true;
}

//
// Devuelve el elemento del tope de la pila, falso si la pila est vacia
bool pila::top(char& dato){
	if(vacia())
		return false;
	dato=elem[tope];
	return true;
}

//
// Saca el elemento del tope de la pila y lo devuelve el el parmetro dato
bool pila::pop(char& dato){
	if(vacia())
		return false;
	dato=elem[tope--];
	return true;
}


const string OPEN = "([{";

const string CLOSE = ")]}";

bool isOpen (char ch){
    return OPEN.find(ch) != string::npos;
}

bool isClose(char ch) {
    return CLOSE.find(ch) != string::npos;
}

bool isBalanced(const string& expresion){
    pila p;
    bool balanceado = true;

    string::const_iterator iter = expresion.begin();
    while (balanceado && (iter != expresion.end())){
        char next_ch = *iter;
        if (isOpen(next_ch)){
            p.push(next_ch);
        } else if (isClose(next_ch)){
            if (p.vacia()){
                balanceado = false;
            } else{
                char top_ch;
                p.pop(top_ch);
                balanceado = OPEN.find(top_ch) == CLOSE.find(next_ch);
            }
        }
        ++iter;
    }
    return balanceado && p.vacia();
}

main(){

    cout << "Introducir una expresion:\n";
    string expresion;
    while (getline(cin, expresion) && (expresion != "")){
        cout << endl << expresion;
        if (isBalanced(expresion)){
            cout << " Esta Equilibarada" << endl;
        } else {
            cout << "  No esta Equilibrada" << endl;
        }
        cout << "\nIntroducir otra expresion: \n";
    }
    return 0;
}


