#include <stdio.h>
#include <iostream>
using namespace std;

#define MAX_ELEMENTOS 15

class lista {
private:
    int longitud;     // Indica la longitud actual de la lista
	int actual;       // Indica el elemento actual que se est accesando
	int elementos[MAX_ELEMENTOS];
public:
    lista();
    int insertarElemento(int element, int pos);
    int obtenerElemento(int pos);
    int eliminarElemento(int pos);
    int longitudLista();
    int primerElemento();
    int siguienteElemento();
    int actualElemento();
    void anularLista();
    void listarElementos();
};

//
// Constructor de la clase lista
lista::lista(){
  anularLista();
}

//
// Inserta un elemento en la posicin indicada,
// si no se indica posicin entonces se inserta de ltimo
int lista::insertarElemento(int element, int pos=-1){
	register int i;

	if (pos == -1)
        pos = (longitud==0?1:longitud+1);

	if(longitud==MAX_ELEMENTOS || pos<1 || pos>longitud+1)
		return 0;
  	for(i=longitud;i>=pos;i--)
		elementos[i]=elementos[i-1];
	elementos[pos-1]=element;
	longitud++;
	return 1;
};

//
// Devuelve un elemento dado una posicin
// -1 si la posicin no existe
int lista::obtenerElemento(int pos){
	if(pos<1 || pos>longitud)
		return -1;
	return elementos[pos-1];
};

//
// Elimina un elemento dada su posicin
// -1 si la posicin no existe
int lista::eliminarElemento(int pos){
	register int i;

	if (pos < 1 || pos> longitud)
		return -1;
	longitud--;
	for(i=pos-1;i<longitud;i++)
		elementos[i]=elementos[i+1];
	return 1;
};

//
// Devuelve la longitud de la lista
int lista::longitudLista(){
	return longitud;
};


//
// Devuelve el primer elemento de la lista y setea el iterador
int lista::primerElemento(){
	if(longitud == 0)
		return -1;
	actual=0;
	return elementos[0];
};

//
// Devuelve el siguiente elemento de la lista segn el iterador
// -1 si no hay ms elementos
int lista::siguienteElemento(){
	if (actual+1 >= longitud)
		return -1;
	actual++;
	return elementos[actual];
};

//
// Devuelve la posicin del elemento actual
// -1 si la lista est vacia
int lista::actualElemento(){
	if(longitud==0)
		return -1;
	return actual+1;
}

//
// Crea la lista vacia
void lista::anularLista(){
	longitud = 0;
	actual   = -1;
}

//
// Lista los elementos de la lista en el standar output
void lista::listarElementos(){
	register int i;

	for(i=0;i<longitud;i++)
		cout << elementos[i] << " ";
}


main() {

    lista L; int e;

	printf("\nImplementacion de Lista con Arreglos\n");
	L.insertarElemento(2);
	L.insertarElemento(4);
	L.insertarElemento(3);
	L.insertarElemento(1);
	L.insertarElemento(5);
	L.insertarElemento(3);
	L.insertarElemento(0);
	L.listarElementos();
	cout << endl;
	for(e=L.primerElemento();e!=-1;e=L.siguienteElemento())
		cout << e << " ";
	cout << endl << "Actual: " << L.actualElemento() << endl;

}

